/******************************************************************************
 *	gpmain.c:	OtBbNyCg
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 *
 *	@\:
 *	̃Tv\[X́AOt}gpăC[W`sTv
 *	"C[WҏW.x"{ɂɐFXȋ@\tĂ܂B
 *	t@\̎Ȃ̂́Ayp^[̎gpAJ[pbg̕ύXA
 *	gҏWAăt@C̕ۑAt@C̃[hȂǂłB
 *	t@Co͎ɂ́A^_CAOgpăt@C̓͂𑣂
 *	܂B
 *	܂Ałj[G̃TCY̐ݒ^_CAO\邱
 *	ɂāAG̃TCYύX邱Ƃł܂B
 *	[W֌W̊֐"C[WҏW.x"ł́AgpĂȂ̂
 *	̂ŎQlɂȂƎv܂B
 *
 *	gp@:
 *	"yCg.x"sƁA܂AG̃TCY̏liWO~QTUjƓ
 *	傫̃EBhEJ܂B
 *	IƃfBXNgbvɃJ[IEBhEAc[IEB
 *	hE\`EBhEɊG`Ƃł܂B
 *	Ñc[́AyƂȂĂ܂B
 *	܂AR}hC"LoX.x"ŎgpĂ PIX`̃t@C
 *	w肷邱Ƃɂ肻̃t@C̊G\邱Ƃł܂B
 *	N PIX`̃t@ChbOĂ邱ƂɂĂlɕ\
 *	\łB
 *	ڂgp@ɂẮÃvO̎dlł"gpaint.doc"
 *	ǂނ悤ɂĂB
 */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <sxmemory.h>		/* }𗘗pƂɕKv	*/
#include <console.h>		/* R\[n}l[W𗘗pƂɕKv */
#include <event.h>		/* Cxg}𗘗pƂɕKv	*/
#include <sxgraph.h>		/* Otn}l[W𗘗pƂɕKv */
#include <window.h>		/* EBhE}𗘗pƂɕKv	*/
#include <menu.h>		/* j[}𗘗pƂɕKv	*/
#include <control.h>		/* Rg[}𗘗pƂɕKv	*/
#include <dialog.h>		/* _CAO}𗘗pƂɕKv	*/
#include <text.h>		/* eLXg}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "gpaint.h"		/* ̃vOŗL̃wb_t@C	*/

char _sxkernelcomm[] = SXKERNEL;	/* J[lNR}h		*/

int OldFC;
int OldBC;
int OldPM;
Point OldPS;
int OldFM;

int PaletOrg[16] = {
	     0, 0x5294, 0x0020, 0x003e, 0x0400, 0x07c0, 0x0420, 0x07fe,
	0x8000, 0xf800, 0x8020, 0xf83e, 0x8400, 0xffc0, 0xad6a, 0xfffe
};

/******************************************************************************
 *	main():		C֐
 ******************************************************************************
 */
int main(int argc, char **argv)
{
	ComVal cv;			/* ʕϐ			*/

	cv.argc = argc;
	cv.argv = argv;

	if (!init(&cv)) {		/* s		*/
		showErrDialog(&cv);	/* G[_CAO\	*/
		cv.endFlag = TRUE;	/* ItOZbg	*/
	}
	/* ItOZbg܂Ń[v */
	while (!cv.endFlag) {
		cv.errorCode = 0;	/* G[R[hNA	*/
		/* ^XN}Cxg擾 */
		TSEventAvail(cv.eventMask, &cv.event);
		/* eCxgɑΉs */
		switch (cv.event.ts.what) {
		case E_IDLE:		/* AChCxg		*/
			idleEvent(&cv);
			break;
		case E_MSLDOWN:		/* }EXtg_ECxg	*/
			msLDownEvent(&cv);
			break;
		case E_MSRDOWN:		/* }EXCg_ECxg	*/
			msRDownEvent(&cv);
			break;
		case E_KEYDOWN:		/* L[_ECxg		*/
			keyDownEvent(&cv);
			break;
		case E_UPDATE:		/* Abvf[gCxg		*/
			updateEvent(&cv);
			break;
		case E_ACTIVATE:	/* ANeBx[gCxg	*/
			activateEvent(&cv);
			break;
		case E_SYSTEM1:		/* VXeCxg		*/
		case E_SYSTEM2:
			systemEvent(&cv);
			break;
		}
		if (cv.errorCode != 0)	/* G[H		*/
			showErrDialog(&cv); /* G[_CAO\ */
	}
	/* I葱s */
	endProc(((cv.errorCode == 0) ? EXIT_SUCCESS : EXIT_FAILURE), &cv);

	return 0;
}

/******************************************************************************
 *	init():		
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  
 *				= FALSE: siIj
 *	:	ʕϐ̏AA{[g֐̓o^AEBhE̍쐬
 *		\ȂǂsB
 */
BOOLEAN init(ComVal *pcv)
{
	BOOLEAN resultFlag;
	BitImg *wPtr;

	TSSetAbort(endProc, (long) pcv); /* A{[g֐o^	*/

	if (LOWWORD(SXVer()) < SXVER2) { /* rwVXẽo[W𒲂ׂ */
		pcv->errorCode = 1;	/* o[WQÂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}

	/* ϐ̏s */
	initVal(pcv);
	/* ҂Ԃ}EX|C^\ */
	EMEnCross();
	resultFlag = loadResource(pcv);	/* \[Xׂēǂݍ	*/
	/* ҂Ԃ}EX|C^ɖ߂ */
	EMDeCross();
	if (!resultFlag)		/* ǂݍ߂ȂH		*/
		return FALSE;		/* ŝFALSEԂ	*/

	if (!createWindow(pcv)) {	/* EBhE쐬		*/
		pcv->errorCode = 2;	/* 쐬łȂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}

	if (!createOffScreen(pcv)) {	/* ItXN[쐬	*/
		pcv->errorCode = 9;	/* 쐬łȂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}
	if (!createSubwin(pcv)) {	/* TuEBhE쐬	*/
		pcv->errorCode = 5;	/* 쐬łȂ		*/
		return FALSE;		/* ŝFALSEԂ	*/
	}

	/* uṼrbgC[WPv[ŕۑ */
	wPtr = (*pcv->penImg[pcv->toolStat[2]])->data;
	memcpy(pcv->brushImg, wPtr, 32);

	/* ɃANeBx[gCxĝł̂߂ɈxXg
	   폜 */
	dispSubwin(pcv, 0);		/* TuEBhEXgO */

	/* CEBhEOtBbN^CvŃJgOtɂ */
	setGraph(pcv->windowPtr, G_GRP);
	/* tHA^obNOEhJ[ݒ肷 */
	GMForeColor(15);
	GMBackColor(15);

	WMShow(pcv->windowPtr);		/* EBhE\		*/
	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	initVal():	eϐ̏s
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void initVal(ComVal *pcv)
{
	int i;

	pcv->windowPtr = NULL;		/* EBhE|C^	*/
	pcv->activeFlag = FALSE;	/* ANeButO	*/
	pcv->eventMask = EVENTMASK;	/* Cxg}XN	*/
	pcv->errorCode = 0;		/* G[R[h		*/
	pcv->endFlag = FALSE;		/* ItO		*/
	pcv->offBitsHdl[0] = NULL;
	pcv->offBitsHdl[1] = NULL;
	pcv->wkBitsHdl = NULL;
	pcv->resMap = NULL;
	pcv->offGraphOK = FALSE;
	pcv->wkGraphOK = FALSE;

	strcpy(pcv->fileName, "ݒ.PIX");
	checkDrive(pcv->fileName, 2, 0);
	for (i = 0; i < SUBMAX; i++) {
		/* TuEBhẼ[WnhkNA */
		pcv->subRgnHdl[i] = NULL;

		/* TuEBhE|C^kNA */
		pcv->subwinPtr[i] = NULL;
	}

	pcv->clickTime = 0;		/* }EX{^̃NbN	*/
	pcv->toolKind = 0;		/* c[̎			*/
	/* IĂc[{^̎ */
	pcv->toolStat[0] = 1;		/* yIĂƂ	*/
	pcv->toolStat[1] = 2;		/* hԂIĂƂ */
	pcv->toolStat[2] = 0;		/* uVIĂƂ	*/
	pcv->toolStat[3] = 0;		/* SIĂƂ	*/
	pcv->toolStat[4] = 0;		/* [yIĂƂ	*/
	/* [ỹ[h{^̕\ԁi{j*/
	pcv->lupeStat = 0;
	pcv->moveLock = TRUE;		/* [ẙg͈͂̈ړ֎~tO */
	pcv->paletNo = 3;		/* pbgԍ̏l͂R	*/
	pcv->ptrnNo = 1;		/* p^[ԍ̏l͂P	*/
	/* yp^[F̃tHA^obNOEhJ[؂ւtO */
	pcv->foreBack = 0;
	/* yp^[F̃tHAOEhJ[ */
	pcv->ptrnColor[0] = 3;
	/* yp^[F̃obNOEhJ[ */
	pcv->ptrnColor[1] = 15;
	pcv->ptrnUse = FALSE;		/* p^[gptȌl͂O */
	pcv->penSize.x_y = LONGWORD(1, 1); /* `pyTCYl	*/
	pcv->brushSize.x_y = LONGWORD(16, 16); /* `puVTCYl */
	/* EhN^OɎgp锼a */
	pcv->radius.x_y = LONGWORD(20, 20);
	/* {^i[ݒ]^[]jgpstO ON */
	pcv->disableBtn = TRUE;
	pcv->lupeRate = 4;		/* g䗦 = ~4		*/
	pcv->lupeTool = 0;		/* [ygpÕc[̎ނ̕ۑ */
	pcv->undoFlag = FALSE;		/* UNDO͖			*/
	/* ItXN[prbc̃CfbNX */
	pcv->offIdx = 0;
	pcv->editFlag = FALSE;		/* ҏWtO			*/
	pcv->fileMode = 0;		/* t@Co̓[h		*/
	pcv->sizeDlg = 0;		/* TCYύX^_CAO͔\ */
	pcv->rcLupe.l.l_t = 0;		/* g͈͂̃N^O	*/
	pcv->rcLupe.l.r_b = LONGWORD(100, 100);
}

/******************************************************************************
 *	createWindow():	EBhE̍쐬
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬siIj
 */
BOOLEAN createWindow(ComVal *pcv)
{
	int paramFlags;			/* p[^̗L		*/
	Rect rc;
	Task task;			/* ^XNǗR[h		*/
	LASCII wTitle;

	static Rect winSize = { 0, 0, WIN_H, WIN_V }; /* EBhETCY */

	TSGetTdb(&task, TS_OWN);	/* ^XNǗR[h擾	*/
	paramFlags = TSTakeParam(	/* R}hC͂	*/
		task.command,		/* R}hC		*/
		&rc,			/* w肳ꂽEBhEʒu	*/
		NULL,			/* ŏIi[Ȃ	*/
		0,			/* AhXe[uۑȂ	*/
		NULL,			/* AhXe[u쐬Ȃ	*/
		NULL);			/* |C^mۂȂ		*/
	if (!(paramFlags & 1)) {	/* EBhEʒu̎w肪邩H */
		/* ȂꍇAVXeEBhE̍W擾 */
		rc = winSize;
		GMSlideRect(&rc, TSGetWindowPos());
	}

	/* t@C^Cgɐݒ肷 */
	wTitle[0] = sprintf((char *) &wTitle[1], "%s %s", WINTITLE, pcv->fileName);
	pcv->windowPtr = WMOpen(	/* EBhEI[v	*/
		NULL,			/* EBhE|C^mۂ	*/
		&rc,			/* EBhE̕\ʒu		*/
		wTitle,			/* EBhE^Cg		*/
		FALSE,			/* I[vɕ`悵Ȃ	*/
		/* OtBbNT|[g^Cg̍LWEBhE */
		WI_STDG2 << 4,
		W_FRONT,		/* ԎOɕ\		*/
		TRUE,			/* N[Y{^gp	*/
		TSGetID());		/* ̃^XNhc		*/
	if (pcv->windowPtr == NULL)
		return FALSE;		/* ŝFALSEԂ	*/

	return TRUE;			/* ̂TRUEԂ	*/
}

/******************************************************************************
 *	idleEvent():	AChCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	J[\̓_ŕ\sB
 */
void idleEvent(ComVal *pcv)
{
	/* t@Co͋^_CAO\Ă */
	if (pcv->fileMode != 0) {
		/* CEBhEeLXg^CvŃJgOtɂ */
		setGraph(pcv->windowPtr, G_TXT);
		/* ANZXy[WOƂPy[Wɂ */
		GMAPage(G_PAGE0 | G_PAGE1);
		OldPM = GMPenMode(G_PSET); /* y[hPSET */
		OldFM = GMFontMode(G_PSET); /* tHg[hPSET */
		/* tHAOEhJ[ɂ */
		OldFC = GMForeColor(G_BLACK);
		/* obNOEhJ[𔒂ɂ */
		OldBC = GMBackColor(G_WHITE);

		/* J[\_ł */
		TMEventW(pcv->fTEditHdl, &pcv->event);

		GMPenMode(OldPM);	/* y[hɖ߂		*/
		GMFontMode(OldFM); /* tHg[hɖ߂	*/
		GMForeColor(OldFC);	/* tHAOEhJ[ɖ߂ */
		GMBackColor(OldBC);	/* obNOEhJ[ɖ߂ */
	}
}

/******************************************************************************
 *	msLDownEvent():	}EXtg_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:
 *	EBhEŃ}EX̍{^ꂽꍇ̏sB
 *	̏ŃN[Y{^ɂIAEBhËړ\ƂȂ܂B
 */
void msLDownEvent(ComVal *pcv)
{
	int partCode;			/* EBhẼp[gR[h	*/
	int num, i;
	LPoint lpt;
	Window *wTemp;			/* e|EBhE|C^	*/

	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		/* EBhECANeBuŁAOPT.1L[ĂȂH */
		if (!pcv->activeFlag && !(pcv->event.ev.how & KS_OPT1)) {
			/* EBhEANeBuɂ */
			WMSelect(pcv->windowPtr);
			/* {^ꂽꏊ̃p[gR[h擾 */
			partCode = WMFind(pcv->event.ev.where.x_y, &wTemp);
			/* ^Cgo[ȊOA{^ꂽH */
			if (partCode != W_INDRAG || !EMLStill())
				return;
		}
		/* }EX̃{^ĂԁAEBhE̊e폈
		   VXeɔCāA{^ꂽA܂͗ꂽꏊ
		   p[gR[h擾 */
		partCode = SXCallWindM(pcv->windowPtr, &pcv->event);
		switch (partCode) {
		case W_INCLOSE:		/* N[Y{^		*/
			if (pcv->editFlag) { /* ҏWH		*/
				num = DMError(D_EXEC, "݂܂ł̕ҏWʂj܂B");
				if (num == 2)
					break;
			}
			pcv->endFlag = TRUE; /* ItOZbg	*/
			break;
		case W_ININSIDE:	/* EBhE̓		*/
			/* CEBhEJgOtɂ */
			GMSetGraph(&pcv->windowPtr->graph);
			lpt = GMGlobalToLocal(pcv->event.ev.where.x_y);
			/* t@Co̓_CAO\H */
			if (pcv->fileMode > 0)
				checkFileDlg(pcv, lpt);
			/* TCYݒ_CAO\H */
			else if (pcv->sizeDlg > 0)
				checkSizeDlg(pcv);
			/* EBhEANeBuH */
			else if (pcv->activeFlag) {
				/* }EX{^ꂽƂ̕`揈 */
				switch (pcv->toolKind) {
				case 0:	/* y				*/
				case 1:	/* hԂ			*/
					switch (pcv->toolStat[pcv->toolKind]) {
					case 1:
						if (pcv->toolKind == 0)
							/* M */
							paintPen(pcv, lpt);
						else
							/* F̗̈̓hԂ */
							paintOfDomain(pcv, lpt);
						break;
					case 5:	/* [W		*/
						paintRgn(pcv, lpt);
						break;
					default:
						/* A`Aʎ蒷`Aȉ~ */
						paintFig(pcv, lpt);
						break;
					}
					break;
				case 2:	/* uV			*/
				case 3:	/* S			*/
					paintBrush(pcv, lpt);
					break;
				case 4:	/* [y			*/
					/* [ẙg͈͂ړłȂ*/
					if (!pcv->moveLock)
						moveLupeRect(pcv, lpt);
					break;
				}
			}
			break;
		}
	} else {
		for (i = 0; i < SUBMAX; i++) {
			/* CxgTuEBhEH */
			if (pcv->subwinPtr[i] != NULL
			 && pcv->event.ev.whom.win == &pcv->subwinPtr[i]->win) {
				/* TuEBhEp̃Cxgs */
				msLDownSubwin(pcv, i);
				break;
			}
		}
	}
}

/******************************************************************************
 *	msRDownEvent():	}EXCg_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	EBhEŃ}EX̉E{^ꂽꍇ̏sB
 */
void msRDownEvent(ComVal *pcv)
{
	/* Cxg̃EBhEŁA
	   EBhEANeBuAOPT.1L[ꂽH */
	if (pcv->event.ev.whom.win == pcv->windowPtr
	 && (pcv->activeFlag || pcv->event.ev.how & KS_OPT1)) {
		/* t@Co͋^_CAO\Ă邩H */
		if (pcv->fileMode != 0) {
			/* CEBhEeLXg^CvŃJgOt
			   ɂ */
			setGraph(pcv->windowPtr, G_TXT);
			/* ANZXy[WOƂPy[Wɂ */
			GMAPage(G_PAGE0 | G_PAGE1);
			/* tHg[hPSETɂ */
			OldFM = GMFontMode(G_PSET);
			/* tHAOEhJ[ɂ */
			OldFC = GMForeColor(G_BLACK);
			/* obNOEhJ[𔒂ɂ */
			OldBC = GMBackColor(G_WHITE);
			/* |bvAbvj[ */
			TMEventW(pcv->fTEditHdl, &pcv->event);
			GMFontMode(OldFM); /* tHg[hɖ߂ */
			/* tHAOEhJ[ɖ߂ */
			GMForeColor(OldFC);
			/* obNOEhJ[ɖ߂ */
			GMBackColor(OldBC);
		} else
			selectMenu(pcv); /* j[̍쐬ƑIs */
	}
}

/******************************************************************************
 *	selectMenu():	|bvAbvj[̍쐬ƑI
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void selectMenu(ComVal *pcv)
{
	int num;			/* j[̃ACeԍ	*/
	Menu **menuHdl;			/* j[nh		*/
	char str[256];

	static char *menuItem[13] = {	/* j[ACe		*/
		",",
		"~ ,",
		"J[IEBhEJ,",
		"c[IEBhEJ,",
		"~ ,",
		"ۑ,",
		"ǂݍ,",
		"~ ,",
		"UNDOgp",
		"G̃TCYύX",
		",",
		"Ȃ,"
	};

	/* j[`̍쐬 */
	str[0] = 0;
	if (!pcv->undoFlag)		/* UNDOgpȂH		*/
		strcat(str, "~");	/* IłȂ		*/
	strcat(str, menuItem[0]);	/* 			*/
	strcat(str, menuItem[1]);	/* 󔒍s			*/
	/* J[IEBhE\Ă邩H */
	if (!pcv->activeFlag || pcv->subwinPtr[COLOR] != NULL)
		strcat(str, "~");	/* IłȂ		*/
	strcat(str, menuItem[2]);	/* J[IEBhE		*/
	/* c[IEBhE\Ă邩H */
	if (!pcv->activeFlag || pcv->subwinPtr[TOOL] != NULL)
		strcat(str, "~");	/* IłȂ		*/
	strcat(str, menuItem[3]);	/* c[IEBhE		*/
	strcat(str, menuItem[4]);	/* 󔒍s			*/
	if (!pcv->editFlag)		/* ܂ҏWĂȂH	*/
		strcat(str, "~");	/* IłȂ		*/
	strcat(str, menuItem[5]);	/* ۑ				*/
	strcat(str, menuItem[6]);	/* ǂݍ			*/
	strcat(str, menuItem[7]);	/* 󔒍s			*/
	strcat(str, menuItem[8]);	/* UNDOgp			*/
	strcat(str, ((!pcv->undoFlag) ? menuItem[10] : menuItem[11]));
	strcat(str, menuItem[9]);	/* G̃TCYύX		*/

	menuHdl = MNConvert(NULL, str, MI_PLN); /* j[쐬	*/
	if (menuHdl == NULL) {
		pcv->errorCode = 6;	/* 쐬łȂ		*/
		pcv->endFlag = TRUE;	/* ItOZbg	*/
		return;
	}
	 /* j[̕\ƑIs */
	num = MNSelect(menuHdl, pcv->event.ev.where.x_y);
	MMHdlDispose(menuHdl);		/* j[nh	*/
	switch (num) {
	case 1:				/* 			*/
		execUndo(pcv);		/* UNDO ̏s		*/
		break;
	case 3:				/* J[IEBhEJ	*/
		/* J[IEBhE쐬ĂȂH */
		if (pcv->subwinPtr[COLOR] == NULL) {
			/* J[IEBhE̕\ */
			if (!openSubwin(pcv, COLOR)) {
				pcv->errorCode = 5; /* 쐬łȂ	*/
				/* ItOZbg */
				pcv->endFlag = TRUE;
			}
		}
		break;
	case 4:				/* c[IEBhEJ	*/
		/* c[IEBhE쐬ĂȂH */
		if (pcv->subwinPtr[TOOL] == NULL) {
			/* c[IEBhE̕\ */
			if (!openSubwin(pcv, 2)) {
				pcv->errorCode = 5; /* 쐬łȂ	*/
				/* ItOZbg */
				pcv->endFlag = TRUE;
			}
		}
		break;
	case 6:
	case 7:
		if (pcv->sizeDlg > 0) {
			/* TCYݒ̋^_CAO */
			changePicSize(pcv, 0);
			/* CEBhEJgOtɂ */
			GMSetGraph(&pcv->windowPtr->graph);
		}
		/* t@Co͂̋^_CAO\ */
		if (preperaFInOut(pcv)) {
			pcv->fileMode = num - 5;
			dispEseDlg(pcv, 0);
		} else {
			DMError(D_CONFIRM, "^_CAO쐬ł܂B");
			dispLupeRect(pcv); /* g僌N^O\ */
		}
		break;
	case 9:				/* AhD̃IItݒ肷	*/
		changeUndo(pcv);
		break;
	/* G̃TCYݒ̋^_CAO\ */
	case 10:
		if (createSizeSetCtrl(pcv))
			dispEseDlg(pcv, 1);
		else {
			DMError(D_CONFIRM, "^_CAO쐬ł܂B");
			dispLupeRect(pcv); /* g僌N^O\ */
		}
		break;
	}
}

/******************************************************************************
 *	keyDownEvent():	L[_ECxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	L[̓͂ƁAOPT.1+'Q'L[ł̏IsB
 */
void keyDownEvent(ComVal *pcv)
{
	int shortCut;			/* V[gJbgL[		*/
	int num;
	int lastFC, lastBC, lastPM, lastFM;

	if (pcv->event.ev.how & KS_OPT1) { /* OPT.1L[ꂽH	*/
		/* L[͂啶ɕϊ */
		shortCut = toupper((int) pcv->event.ev.whom.key.ascii);
		if (shortCut == 'Q') {	/* IH			*/
			if (pcv->editFlag) { /* ҏWH		*/
				num = DMError(D_EXEC, "݂܂ł̕ҏWʂj܂B");
				if (num == 2) /* []{^		*/
					return; /* IȂ		*/
			}
			pcv->endFlag = TRUE; /* ItOZbg	*/
		}
	/* t@Co͋^_CAO\Ă邩H */
	} else if (pcv->fileMode != 0) {
		/* CEBhEeLXg^CvŃJgOtɂ */
		setGraph(pcv->windowPtr, G_TXT);
		/* ANZXy[WOƂPy[Wɂ */
		GMAPage(G_PAGE0 | G_PAGE1);
		lastPM = GMPenMode(G_PSET); /* y[hPSET */
		lastFM = GMFontMode(G_PSET); /* tHg[hPSET	*/
		lastFC = GMForeColor(G_BLACK); /* tHAOEhJ[͍ */
		lastBC = GMBackColor(G_WHITE); /* obNOEhJ[͔ */

		switch (pcv->event.ev.whom.key.ascii) {
		case '\r':		/* ^[L[ENTERL[	*/
			execFileDlg(pcv, 1); /* [s]{^Ɠs */
			break;
		case '\x1b':		/* ESCL[			*/
			execFileDlg(pcv, 2); /* []{^Ɠs */
			break;
		default:
			if (pcv->event.ev.whom.key.code != 0)
				/* P͂ */
				TMEventW(pcv->fTEditHdl, &pcv->event);
			break;
		}
		/* CEBhEeLXg^CvŃJgOtɂ */
		setGraph(pcv->windowPtr, G_TXT);
		GMPenMode(lastPM);	/* y[hɖ߂		*/
		GMFontMode(lastFM);	/* tHg[hɖ߂	*/
		GMForeColor(lastFC);	/* tHAOEhJ[ɖ߂ */
		GMBackColor(lastBC);	/* obNOEhJ[ɖ߂ */
	/* G̃TCYݒ^_CAO\Ă邩H */
	} else if (pcv->sizeDlg != 0) {
		switch (pcv->event.ev.whom.key.ascii) {
		case '\r':		/* ^[L[ENTERL[	*/
					/* [s]{^Ɠs	*/
			changePicSize(pcv, 1);
			break;
		case '\x1b':		/* ESCL[			*/
					/* []{^Ɠs	*/
			changePicSize(pcv, 0);
			break;
		default:
			/* UNDOL[ꂽH */
			if (pcv->event.ev.whom.key.code == K_UNDO)
				execUndo(pcv); /* UNDȌs */
			break;
		}
	}
}

/******************************************************************************
 *	updateEvent():	Abvf[g
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:
 *	Abvf[gƂăEBhE`悷B
 *	̏sȂƁA艺̃EBhẼAbvf[gACh
 *	Cxg̏łȂȂ܂B
 */
void updateEvent(ComVal *pcv)
{
	int i;

	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		/* CEBhEeLXg^CvŃJgOtɂ */
		setGraph(pcv->windowPtr, G_TXT);
		/* ANZXy[WOƂPy[Wɂ */
		GMAPage(G_PAGE0 | G_PAGE1);
		OldPM = GMPenMode(G_PSET);
		/* tHAOEhJ[ɂ */
		OldFC = GMForeColor(G_BLACK);
		/* obNOEhJ[𔒂ɂ */
		OldBC = GMBackColor(G_WHITE);
		/* t@Co͋^_CAO\Ă */
		if (pcv->fileMode > 0)
			TMCaret(pcv->fTEditHdl, 0); /* J[\ */

		GMForeColor(OldFC);	/* tHAOEhJ[ɖ߂ */
		GMBackColor(OldBC);	/* obNOEhJ[ɖ߂ */
		GMPenMode(OldPM);

		WMUpdate(pcv->windowPtr); /* Abvf[gJn	*/
		drawGraph(pcv);		/* EBhE`悷	*/
		WMUpdtOver(pcv->windowPtr); /* Abvf[gI	*/
	} else {
		for (i = 0; i < SUBMAX; i++) {
			/* CxgTuEBhEH */
			if (pcv->subwinPtr[i] != NULL
			 && pcv->event.ev.whom.win == &pcv->subwinPtr[i]->win) {
				/* Abvf[gJn */
				WMUpdate(&pcv->subwinPtr[i]->win);
				switch (i) {
				case 0:
					drawColorWnd(pcv);
					break;
				case 1:
					drawPaletWnd(pcv);
					break;
				case 2:
					drawToolWnd(pcv);
					break;
				case 3:
					drawLupeWnd(pcv);
					break;
				case 4:
					break;
				}
				/* Abvf[gI */
				WMUpdtOver(&pcv->subwinPtr[i]->win);
				break;
			}
		}
	}
}

/******************************************************************************
 *	drawGraph():	EBhE̕`
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void drawGraph(ComVal *pcv)
{
	Rect rc;

	/* CEBhEeLXg^CvŃJgOtɂ */
	setGraph(pcv->windowPtr, G_TXT);
	GMAPage(G_PAGE0 | G_PAGE1);	/* ANZXy[WOƂPy[Wɂ */
	OldPM = GMPenMode(G_PSET);

	/* tHAOEhJ[CgO[ɂ */
	OldFC = GMForeColor(G_LGRAY);
	/* EBhEG傫 */
	if (pcv->pictSize.d.right < 340) {
		rc = pcv->nowWinSize;
		rc.d.left = pcv->pictSize.d.right;
		/* CgO[ŃEBhEhԂ */
		GMFillRect(&rc);
	}
	if (pcv->pictSize.d.bottom < 120) {
		rc = pcv->nowWinSize;
		rc.d.top = pcv->pictSize.d.bottom;
		/* CgO[ŃEBhEhԂ */
		GMFillRect(&rc);
	}
	GMForeColor(OldFC);
	GMPenMode(OldPM);

	/* g僌N^O\ */
	dispLupeRect(pcv);

	/* t@Co͋^_CAO\Ă */
	if (pcv->fileMode > 0)
		dispEseDlg(pcv, 0);
	/* TCYݒ^_CAO\Ă */
	else if (pcv->sizeDlg > 0)
		dispEseDlg(pcv, 1);

	/* EBhEŜ` */
	/* CEBhEOtBbN^CvŃJgOtɂ */
	setGraph(pcv->windowPtr, G_GRP);
	/* ItXN[prbcbN */
	GMLockBits(pcv->offBitsHdl[pcv->offIdx]);
	/* rbg}bvZbg */
	pcv->offGraph.bmap = &(*pcv->offBitsHdl[pcv->offIdx])->bmap;

	/* w̃N^O̕ItXN[Rs[ */
	GMTransImg(&(*pcv->offBitsHdl[pcv->offIdx])->bmap, pcv->windowPtr->graph.bmap, &pcv->pictSize, &pcv->pictSize);

	/* ItXN[prbcAbN */
	GMUnlockBits(pcv->offBitsHdl[pcv->offIdx]);

	/* [ẙg͈͂̈ړ֎~tONA*/
	if (pcv->subwinPtr[LUPE] != NULL)
		pcv->moveLock = FALSE;
}

/******************************************************************************
 *	activateEvent():	ANeBx[gCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	ANeBuACANeBuɂANeButO̐؂ւƁA
 *		Cxg}XN̐؂ւsB
 */
void activateEvent(ComVal *pcv)
{
	/* Cxg̃EBhEH */
	if (pcv->event.ev.whom.win == pcv->windowPtr) {
		pcv->activeFlag = TRUE;	/* ANeButOZbg	*/
		/* ANeBũCxg}XNZbg */
		pcv->eventMask = EVENTMASK | EM_IDLE | EM_MSRDOWN | EM_KEYDOWN;
		/* TuEBhE\ */
		dispSubwin(pcv, 1);
		/* pbgZbg */
		setPalet(pcv->oldPaletBuf);
	/* Cxg̃EBhEŁAANeBuԂH */
	} else if (pcv->activeFlag) {
		pcv->activeFlag = FALSE; /* ANeButONA */
		/* CANeBũCxg}XNZbg
		   iYCxg̃^CvAAChCxgA
		   }EXCg_EAL[_EOj*/
		pcv->eventMask = EVENTMASK;
	}
}

/******************************************************************************
 *	systemEvent():	VXeCxg
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	:	SEBhẼN[YAS^XN̏IAEBhẼZNg
 *		ΉsB
 */
void systemEvent(ComVal *pcv)
{
	int num;

	switch (pcv->event.ts.what2) {	/* Cxg̎ނ́H		*/
	case CLOSEALL:			/* SEBhẼN[Y	*/
	case ENDTSK:			/* S^XN̏I		*/
		pcv->endFlag = TRUE;	/* ItOZbg	*/
		break;
	case WINDOWSELECT:		/* EBhẼZNg		*/
		WMSelect(pcv->windowPtr); /* EBhEANeBuɂ */
		break;
	case NOTICEENDTSK:		/* S^XNI̗\		*/
		if (pcv->editFlag) {	/* ҏWH			*/
			num = TSErrDialogN(D_EXEC, "SĂ̕ҏWʂj܂B");
			if (num == 2)
				/* Cxg揜ɂ */
				TSGetEvent(pcv->eventMask, &pcv->event);
		}
		break;
	case DRAGEND:			/* hbȌ		*/
		/* Cxg̃EBhEH */
		if (pcv->event.ev.whom.win == pcv->windowPtr)
			dropIcon(pcv);	/* ACR̃hbvs	*/
		break;
	}
}

/******************************************************************************
 *	dropIcon():	ACR̃hbv
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void dropIcon(ComVal *pcv)
{
	int errCode, len, num;
	int lastFC, lastBC, lastFM;
	LPoint lpt;
	Drag *dragPtr;			/* hbO|C^		*/
	Cell *pcell;			/* ZR[hւ̃|C^	*/
	char path[TS_NAMEMAX];		/* tpX			*/

	/* CEBhEeLXg^CvŃJgOtɂ */
	setGraph(pcv->windowPtr, G_TXT);
	lpt = GMGlobalToLocal(pcv->event.ev.where.x_y);
	if (pcv->fileMode > 0 && !(GMPtInRect(&rcFdlg, lpt)))
		return;

	/* hbO|C^擾 */
	errCode = TSGetDrag(&dragPtr);
	if (errCode < 0)		/* hbOR[hH	*/
		return;

	MMHdlLock(dragPtr->cellList);	/* ZXgւ̃nhbN */
	pcell = *dragPtr->cellList;	/* ZR[hւ̃|C^擾 */
	TSHideDrag();			/* o[oh	*/
	/* ZR[h̏̎ނACRǗR[hiʃ[h'FS'j
	   H */
	if (HIWORD(pcell->kind) == 'FS') {
		/* ACR͂PihbOR[h̃ZXg̒ACR
		   ǗR[h܂ރZR[h̒Ɠ̏ꍇjH */
		if (dragPtr->size == sizeof(IcState) + 8 ) {
			/* ACR̃tpX擾 */
			len = TSISRecToStr(
				(IcState *) pcell->data, /* ACRǗR[h */
				path);	/* pXi[|C^		*/
			if (len != 0) {
				TSEndDrag(TS_FINISH); /* hbOI */
				/* t@C^_CAO\H */
				if (pcv->fileMode > 0) {
					/* ANZXy[WO`Qy[Wɂ */
					GMAPage(G_PAGE0 | G_PAGE1 | G_PAGE2);
					lastFC = GMForeColor(G_BLACK);
					lastBC = GMBackColor(G_WHITE);
					lastFM = GMFontMode(G_PSET);
					/* hbOt@CƃZNg
					   ꊷ */
					TMInsert(pcv->fTEditHdl, path, (int) strlen(path));
					TMSetSelect(pcv->fTEditHdl, 0, (*pcv->fTEditHdl)->length, 0);
					GMFontMode(lastFM);
					GMForeColor(lastFC);
					GMBackColor(lastBC);
				} else {
					/* gGȀ */
					dispLupeRect(pcv);
					num = 1;
					if (pcv->editFlag) /* ҏWH */
						num = DMError(D_EXEC, "݂܂ł̕ҏWʂj܂B");
					if (num == 1) {
						/* t@Cǂݍ */
						loadFile(pcv, path);
						/* ׂẴEBhE
						   Abvf[gs */
						allUpdate(pcv);
					}
				}
			} else
				/* ACR̈ʒuɂ͂΂ďI */
				TSEndDrag(TS_PUTBACK);
		} else
			/* ACR̈ʒuɂ͂΂ďI */
			TSEndDrag(TS_PUTBACK);
	} else
		/* ACR̈ʒuɂ͂΂ďI */
		TSEndDrag(TS_PUTBACK);
	/* ZXgւ̃nh̃bN */
	MMHdlUnlock(dragPtr->cellList);
}

/******************************************************************************
 *	showErrDialog():	G[_CAO̕\
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 */
void showErrDialog(ComVal *pcv)
{
	int i;

	static struct {			/* G[			*/
		int code;		/* G[R[h			*/
		int manager;		/* gp}l[W		*/
		int flag;		/* \tbO			*/
		char *message;		/* G[bZ[W		*/
	} errInfo[] = {
		{  1, 1, D_RED,    "SX SYSTEM̃o[WႢ܂B" },
		{  2, 2, D_RED,    "EBhE쐬ł܂B\r"
				   "ʃ[hύXĂB" },
		{  3, 2, D_RED,    "Rg[쐬ł܂B" },
		{  5, 2, D_RED,    "TuEBhE쐬ł܂B" },
		{  6, 1, D_RED,    "j[쐬ł܂B" },
		{  8, 2, D_YELLOW, "mۂł܂B" },
		{  9, 2, D_RED,    "ItXN[쐬ł܂B" },
		{ 11, 2, D_RED,    "\[Xt@Ct܂B" },
		{ 12, 2, D_RED,    "\[Xt@CI[vł܂B" },
		{ 13, 2, D_RED,    "\[X̓ǂݍ݂Ɏs܂B" },
		{ 14, 2, D_RED,    "\[X̎擾Ɏs܂B" },
		{  0, 1, D_YELLOW, "G[܂B" }
	};

	for (i = 0; errInfo[i].code != 0; i++) /* G[R[h{	*/
		if (errInfo[i].code == pcv->errorCode)
			break;
	switch (errInfo[i].manager) {	/* }l[W̑I		*/
	case 1:				/* _CAO}		*/
		DMError(errInfo[i].flag | D_CONFIRM, errInfo[i].message);
		break;
	case 2:				/* ^XN}			*/
		TSErrDialogN(errInfo[i].flag | D_CONFIRM, errInfo[i].message);
		break;
	}
}

/******************************************************************************
 *	endProc():	I葱
 ******************************************************************************
 *	:	int code	IR[h
 *		ComVal *pcv	ʕϐւ̃|C^
 *	:	nh̉EBhE̔pƁAvȌIsB
 */
void endProc(int code, ComVal *pcv)
{
	int i;

	for (i = 0; i < SUBMAX; i++) {
		if (pcv->subwinPtr[i] != NULL) {
			/* Rg[nhp */
			CMKill(&pcv->subwinPtr[i]->win);
			/* EBhEp */
			WSDispose(pcv->subwinPtr[i]);
		}
		if (pcv->subRgnHdl[i] != NULL)
			/* [Wnh */
			GMDisposeRgn(pcv->subRgnHdl[i]);
	}
	/* ^_CAOłĂ*/
	if (pcv->fileMode != 0 || pcv->sizeDlg != 0)
		/* Rg[p */
		CMKill(pcv->windowPtr);
	/* EBhE|C^mۂꂽ܂܂H */
	if (pcv->windowPtr != NULL)
		WMDispose(pcv->windowPtr); /* EBhEp	*/

	if (pcv->offBitsHdl[0] != NULL)
		/* ItXN[prbcnhp */
		GMDisposeBits(pcv->offBitsHdl[0]);

	if (pcv->offBitsHdl[1] != NULL)
		/* ItXN[prbcnhp */
		GMDisposeBits(pcv->offBitsHdl[1]);

	if (pcv->wkBitsHdl != NULL)
		/* [Np̃rbcnhp */
		GMDisposeBits(pcv->wkBitsHdl);

	/* ItXN[pOt쐬Ă邩H */
	if (pcv->offGraphOK) {
		/* rbg}bv|C^kɂ */
		pcv->offGraph.bmap = NULL;
		/* OtN[Y */
		GMCloseGraph(&pcv->offGraph);
	}
	/* [NpOt쐬Ă邩H */
	if (pcv->wkGraphOK) {
		/* rbg}bv|C^kɂ */
		pcv->wkGraph.bmap = NULL;
		/* OtN[Y */
		GMCloseGraph(&pcv->wkGraph);
	}
	/* \[XI[vĂ */
	if (pcv->resMap != NULL)
		TSResRemove();		/* Jg\[X̍폜	*/
	/* t@Co͋^_CAO\Ă */
	if (pcv->fileMode != 0 && pcv->fTEditHdl != NULL)
		TMDispose(pcv->fTEditHdl); /* eLXgp	*/
	/* pbglɖ߂ */
	setPalet(PaletOrg);

	exit(code);			/* vOI		*/
}

/******************************************************************************
 *	setGraph():	މʂ̐؂ւs
 ******************************************************************************
 *	:	Window *winPtr	EBhE|C^
 *		int type	= G_TXT: eLXg^Cv
 *				= G_GRP: OtBbN^Cv
 */
void setGraph(Window *winPtr, int type)
{
	GMSetGraph(&winPtr->graph);
	switch (type) {
	case G_TXT:			/* eLXg^Cv		*/
		winPtr->graph.bmap->type = G_TXT;
		winPtr->graph.bmap->base = G_TXTBASE;
		winPtr->graph.bmap->line = G_TXTLINE;
		winPtr->graph.bmap->opt.tbm.page = G_TXTPAGE;
		/* ANZXy[WSy[Wɂ */
		winPtr->graph.bmap->opt.tbm.aPage = G_ALLPAGE;
		break;
	case G_GRP:			/* OtBbN^Cv		*/
		winPtr->graph.bmap->type = G_GRP;
		winPtr->graph.bmap->base = G_GRPBASE;
		winPtr->graph.bmap->line = G_GRPLINE;
		break;
	}
}

/******************************************************************************
 *	repeatAdjBtn():	l{^̃s[g
 ******************************************************************************
 *	:	ComVal *pcv		ʕϐւ̃|C^
 *		Window *winPtr		EBhE|C^
 *		Control **hadjbtn	l{^̃Rg[nh
 *		Control **hsldvol	XCh{[̃Rg[nh
 *		int partCode		Rg[̃p[gR[h
 *		int len			Rg[^Cg̕\
 *	:
 *	l{^ꂽ܂܂̂ƂAs[gs܂B
 *	s[gԂ̒̂߂̃fBCsARg[̒lύX܂B
 */
void repeatAdjBtn(ComVal *pcv, Window *winPtr, Control **hadjbtn, Control **hsldvol, int partCode, int len)
{
	int max, min, val;		/* l{^̒l		*/
	int start;			/* s[gJñVXe	*/
	int wait = ADJFIRST;		/* Ҏԁis[gJnԁj	*/
	Control **ctrlHdl = hadjbtn;	/* Rg[nh		*/
	char str[16];

	max = CMMaxGet(ctrlHdl);	/* Rg[̍ől擾 */
	min = CMMinGet(ctrlHdl);	/* Rg[̍ŏl擾 */
	/* }EX̍{^܂ŁAs[gs */
	do {
		start = EMSysTime();	/* VXeԂ擾	*/
		/* Ă̂͐l{^H */
		if (ctrlHdl == hadjbtn) {
			/* ꂽ{^\ */
			CMShine(ctrlHdl, partCode);
			val = CMValueGet(ctrlHdl); /* ݒl擾	*/
			switch (partCode) {
			case C_ININC:		/* {^		*/
				if (++val > max) /* lől傫H */
					val = max;
				break;
			case C_INDEC:		/* {^		*/
				if (--val < min) /* lŏl菬H */
					val = min;
				break;
			}
			/* oߎԂҎԂ̔߂邩A
			   {^܂ő҂ */
			while (EMSysTime() - start < wait / 2 && EMLStill())
				;
			CMValueSet(ctrlHdl, val); /* VlZbg */
			/* Rg[^Cg */
			str[0] = sprintf(&str[1], "%*d", len, val);
			CMTitleSet(ctrlHdl, (_LASCII)str);
			/* XCh{[̒lݒ肷 */
			CMValueSet(hsldvol, val);
			/* oߎԂҎԂ߂邩A
			   {^܂ő҂ */
			while (EMSysTime() - start < wait && EMLStill())
				;
			wait = ADJNEXT;	/* ҎԂɃs[gԊuݒ肷 */
		}
		/* }EXRg[̏ォׂ */
		partCode = CMFind(EMMSLoc(), winPtr, &ctrlHdl);
	} while (EMLStill());		/* {^ꂽI */
}

/******************************************************************************
 *	addUpdate():	Abvf[g[WɃN^Oǉ
 ******************************************************************************
 *	:	Window *winPtr	EBhE|C^
 *		Rect *prc	N^Oւ̃|C^
 *				= NULL: EBhES
 *	:	Abvf[gCxg𔭐
 */
void addUpdate(Window *winPtr, Rect *prc)
{
	Rect rc;

	if (prc == NULL)
		/* |C^ NULL ̏ꍇ̓EBhEŜ */
		rc = winPtr->graph.rect;
	else
		rc = *prc;
	GMSetGraph(&winPtr->graph);	/* JgOtɂ	*/
	GMSlideRect(&rc, GMLocalToGlobal(0)); /* O[oWnɕϊ */
	WMAddRect(&rc);			/* Abvf[g[Wɒǉ */
}
